#include <stdio.h>
 int main()
 {
 int N,i,a,b,koren,max_vuzel,br_vuzli,vuzli[2001][2];
 koren=max_vuzel=br_vuzli=0;
 for(i=0;i<2001;i++)
   vuzli[i][0]=vuzli[i][1]=0;
 scanf("%d",&N);
 for(i=0;i<N;i++)
 {
 scanf("%d%d",&a,&b);
 if(vuzli[b][0]){ printf("0 0"); return 0;}
 vuzli[b][1]=1;vuzli[a][1]=1;vuzli[b][0]=a;
 if(a>max_vuzel) max_vuzel=a;
 if(b>max_vuzel) max_vuzel=b;
 }
 for(i=0;i<=max_vuzel;i++)
	if(vuzli[i][1]) if(!vuzli[i][0])
	{if(koren) {koren=0;printf("0 0");return 0;}
	else koren=i;
	}

	for(i=0;i<=max_vuzel;i++)
	if(vuzli[i][1]) br_vuzli++;

	printf("%d %d",br_vuzli,koren);

 return 0;
 }